import { useState } from "react";
import Taro from '@tarojs/taro'

import request from '../util/request'

export default function useUser() {
    const [user, setUser] = useState()

    const getUser = code => {
        request({url:`/login?code=${code}`,method:"POST"}).then((res)=>{
          console.log(res.data.data,'res')
          setUser(res.data.data)

          Taro.setStorage({
            key:"token",
            data:res.data.data.token
          })
        })
    }

    return {
        user,
        getUser,
    }
}
